;;;; sort-passwd.scm - Sort /etc/passwd file

(use awk regex extras)

(define (read-passwd . port)
  (let ([line (apply read-line port)])
    (if (eof-object? line)
	(values line #f)
	(values line (string-split-fields ":" line #:infix)))))

(for-each
 (lambda (entry) (print (cdr entry)))
 (sort
  (awk (read-passwd) (line fields) ([ans '()])
    (#t (cons (cons (car fields) line) ans)) ) 
  (lambda (x y) (string<? (car x) (car y)))))